#include "usart.h"
#include "device.h"
#include "spi2.h"
#include "ult.h"
#include "socket.h"
#include "w5500.h"
#include "24c16.h"
#include "md5.h"
#include "string.h"

extern uint8 txsize[];										// ⲿSocketͻС
extern uint8 rxsize[];										// ⲿSocketջС

uint8 buffer[2048];												// һ2KB飬Socketͨ

int main(void)
{
  uint16 local_port=5000;												// һض˿ڲʼ
  uint16 len=0; 													

	/***** MCUʱӳʼ *****/							  
	Systick_Init(72);	
	
	/***** жϿ *****/
	NVIC_Configuration();
	
	/***** GPIOSPIʼ *****/
	GPIO_Configuration();			
	WIZ_SPI_Init();
	
	/***** ڳʼ *****/
	USART1_Init(); 		
	
	/***** ʼeeprom *****/
  at24c16_init();
	
	/***** ӲW5500 *****/
	Reset_W5500();
	
	/***** W5500IPϢʼ *****/
	set_default(); 														// ĬMACIPGWSUBDNS
	set_network();														// óʼIPϢӡʼ8Socket
	
	/***** W5500Keepalive *****/
	setkeepalive(0);
	
	printf("TCP Server Port:%d\r\n",local_port);
	printf("W5500 Init Complete!\r\n");
  printf("Start TCP Server Test!\r\n"); 

	/*Socket״̬MCUͨSn_SR(0)ֵжSocketӦôں״̬
		Sn_SR״̬
		0x00		SOCK_CLOSED
		0x13		SOCK_INIT
		0x14		SOCK_LISTEN
		0x17		SOCK_ESTABLISHED
		0x1C		SOCK_CLOSE_WAIT
		0x22		SOCK_UDP
	*/
	while(1)																	// Socket״̬
	{
		int i;
		for(i=0;i<=7;i++)
		{
			switch(getSn_SR(i))										// ȡsocketi״̬
			{
				case SOCK_INIT:											// Socketڳʼ()״̬
//					printf("%d-1 ",i);
				Delay_ms(500);
						listen(i);											// ոմ򿪵ıض˿ڣȴͻ
				break;
				case SOCK_ESTABLISHED:							// Socketӽ״̬			
//											printf("%d-2 ",i);
				Delay_ms(500);
//					printf("%d Connected\r\n",i);
					Delay_ms(1000);
					if(getSn_IR(i) & Sn_IR_CON)			
						{
							setSn_IR(i, Sn_IR_CON);				// Sn_IRCONλ1֪ͨW5500ѽ
							
						}
						// ݻػԳݴλͻ˷W5500W5500յݺٻظͻ
						len=getSn_RX_RSR(i);						// ȡW5500нջĴֵlenSn_RX_RSRʾջѽպͱݴС
						if(len>0)
						{
							recv(i,buffer,len);						// W5500Կͻ˵ݣͨSPI͸MCU
							printf("%d:%s\r\n",i,buffer);	// ڴӡյ
							send(i,buffer,len);						// յݺٻظͻˣݻػ
						}
						// W5500Ӵڷݸͻ˳Իس
						if(USART_RX_STA & 0x8000)				// жϴǷ
						{					   
							len=USART_RX_STA & 0x3fff;		// ȡڽյݵĳ
							send(i,USART_RX_BUF,len);			// W5500ͻ˷
							USART_RX_STA=0;								// ڽ״̬־λ0
							memset(USART_RX_BUF,0,len+1);	// ڽջ0
						}
				break;
				case SOCK_CLOSE_WAIT:								// Socketڵȴر״̬
//										printf("%d-3 ",i);
				Delay_ms(500);
						close(i);												// رSocketi
				break;
				case SOCK_CLOSED:										// Socketڹر״̬
//										printf("%d-4 ",i);
				Delay_ms(500);
						socket(i,Sn_MR_TCP,local_port,Sn_MR_ND);		// SocketiΪTCPʱģʽһض˿
				break;
			}
		}
	}
}

